package src;

import java.io.*;
import java.net.*;
import java.util.concurrent.ConcurrentLinkedQueue;

public class MultiClient
{
	public static void main(String[] args) throws IOException {
		
		for(int i =0 ; i< Param.NUM_MSS;i++)
			new ClientThread("Client"+i,Param.BSS_IP,Param.BSS_BCAST_PORT,Param.DATA_RATE[i]);
    }
}
class ClientThread extends Thread {

    protected MulticastSocket socket = null;
    protected boolean keepStreaming = true;
    int retrieve_rate = 0;
    InetAddress address;
    String name;
    private RandomAccessFile fp = null;
    public ClientThread(String name,String bss_ip,int bss_port, int r) throws IOException {
    	super(name);
    	this.name = name;
    	String path = name+"_recon.yuv";
    	new File(path).delete();
    	this.fp = new RandomAccessFile(path, "r");
       	this.retrieve_rate = r;
    	MulticastSocket socket = new MulticastSocket(bss_port);
        this.address = InetAddress.getByName(bss_ip);
        socket.joinGroup(address);

    	System.out.println(this.name+" thread ready");
    }

    public void run() {
    	int i = 0;
    	try{
    		while (keepStreaming && i< 1024)  {
    			int chunk_size = this.retrieve_rate*1024;//8kb chunks
		        byte[] buf = new byte[chunk_size];
		        DatagramPacket packet = new DatagramPacket(buf, buf.length);
		        socket.receive(packet);
		        fp.write(buf, 0, chunk_size);
		        //    System.out.println((i+1)*32+"kb data received and wrote to file");
    		}
    		fp.close();
    		socket.leaveGroup(this.address);
    		socket.close();
    		System.out.println(this.name+" thread ready");
    	}catch (Exception e) {
	            e.printStackTrace();
	        	keepStreaming = false;
        }
       
    }
}