package src;

import java.io.*;
import java.net.*;

public class Server
{
	public static void main(String[] args)throws IOException{
		for(int i =0; i<Param.NUM_STREAM;i++)
			new StreamThread("Stream"+i,Param.STREAM[i],Param.CS_PORT[i],Param.DATA_RATE[i]).start();
	}
}

class StreamThread extends Thread {

    protected MulticastSocket socket;
    protected boolean keepStreaming;
    private RandomAccessFile fp;
    int port,send_rate;
    private String name;
    public StreamThread(String name,String path,int port, int r) throws IOException {
        super(name);
        this.name = name;
        this.port = port;
        this.send_rate = r;
        this.fp = new RandomAccessFile(path, "r");
        socket = new MulticastSocket(this.port);
        this.keepStreaming = true;
        System.out.println(name+" thread ready");
    }

    public void run() {
    	int size =0;
        while (keepStreaming) {
	        try {
	        	int chunk_size = this.send_rate*1024; //read r kb chunks
	        	byte[] buf = new byte[chunk_size];
	            buf = getBytes(chunk_size);
	            InetAddress group = InetAddress.getByName(Param.CS_IP);
	            DatagramPacket packet = new DatagramPacket(buf, buf.length, group, this.port);
	            socket.send(packet); size = size + this.send_rate;
	   		    //System.out.println(this.name+" sent "+this.send_rate+"kb data now. Total sent:"+size+"kb. ");
	       		try {
	       		    sleep((long)(1 * 1000));
	       		}catch (InterruptedException e) {
	       			
	       		}
	        }catch (Exception e) {
	            e.printStackTrace();
	        	keepStreaming = false;
	        }
        }
        socket.close();
    }
    protected byte[] getBytes(int chunk_size) {
    	byte[] temp = new byte[chunk_size];
        try {
        	fp.readFully(temp, 0, chunk_size);
        } catch (EOFException eofe) {
            System.out.println(eofe.getMessage());//"EOF reached for file: "+this.fp);
        }catch (Exception e) {
        	System.out.println(e.getMessage());e.printStackTrace();
        }
        return temp;
    }
}
