package test;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Random;

import src.ScalableVideo;
import src.YUVHandler;

public class TestCase0 {
	static Random rand = new Random();
	public static void main(String[] args)throws Exception{
		getNTData(2,200);
	}
	
	//returns NcxTs data in diff form
	public static ScalableVideo[][] getNTData(int NC,int T)throws Exception{
		int slen = 10;
		ScalableVideo[][] ntsv = new ScalableVideo[T][slen*NC];
		for(int t=0;t<T;){
			int start  = rand.nextInt(slen);
			for(int s= 0;s<(slen-start) && ((t+s)<T);s++){
				//System.out.print("["+(t+s)+" "+(start+s)+"]:");
				ntsv[t+s] = getCData(NC,start+s);
			}
			//System.out.print("[==]");
			for(int s= slen-start;(s<slen) && ((t+s)<T);s++){
				int idx = s-(slen-start);
				//System.out.print("["+(t+s)+" "+idx+"]:");
				ntsv[t+s] = getCData(NC,idx);
			}
			t=t+slen;
			//System.out.println();
		}
		return ntsv;
	}
	//returns Ncx1s data in diff form
	public static ScalableVideo[] getCData(int NC,int sec)throws Exception{
		boolean ifDiff = true;
		if(sec>=10)throw new Exception("Error sec>=10 : "+sec);
		ScalableVideo[] sv = ifDiff ? getDiffData(sec):getData(sec);
		ScalableVideo[] nsv = new ScalableVideo[sv.length*NC];
		for(int n =0;n<NC;n++){
			for(int s= 0;s<(sv.length-n);s++){
				//System.out.print("["+(n*sv.length+s)+" "+(n+s)+"]");
				nsv[n*sv.length+s] = sv[n+s];
			}
			//System.out.print("[-]");
			for(int s= sv.length-n;s<sv.length;s++){
				int idx = s-(sv.length-n);
				//System.out.print("["+(n*sv.length+s)+" "+idx+"]");
				nsv[n*sv.length+s] = sv[idx];
			}
		}
		//System.out.println();
		return nsv;
	}

	//returns 10cx1s data in difference form
	public static ScalableVideo[] getDiffData(int sec)throws Exception{
		ScalableVideo[] sv = getData(sec);
		ScalableVideo[] dsv = new ScalableVideo[sv.length];
		for(int i=0;i<sv.length;i++){
			dsv[i] = new ScalableVideo(sv[i].name,sv[i].numL);
			dsv[i].addInfo(0,sv[i].getRate(0),sv[i].getPSNR(0) );
			for(int j=1;j<sv[i].numL;j++){
				int rate = sv[i].getRate(j-1);
				double psnr = sv[i].getPSNR(j-1);
				dsv[i].addInfo(j,sv[i].getRate(j)-rate ,sv[i].getPSNR(j)-psnr );
			}
			//dsv[i].print();
		}
		return dsv;
	}
	//the most elementary 10cx1s data 
	public static ScalableVideo[] getData(int sec)throws Exception{
		String[] names = {"CREW","FOOTBALL","MOBILE","CITY","FOREMAN","BUS","NEWS","HARBOUR","SOCCER","ICE"};
		String[] sec_prefix = {"1st","2nd","3rd","4th","5th","6th","7th","8th","9th","xth"};
		BufferedReader br = new BufferedReader(new FileReader(sec_prefix[sec]+"/rates.txt"));
		BufferedReader bp = new BufferedReader(new FileReader(sec_prefix[sec]+"/psnrs.txt"));
		int minr,maxr; minr = maxr =0;
		int minf,maxf; minf = maxf =0;
		double minp,maxp; minp = maxp =0.0;
		ScalableVideo[] sv = new ScalableVideo[names.length];
		for(int i=0;i<names.length;i++){
			sv[i] = new ScalableVideo(names[i],4);
			for(int j=0;j<4;j++){
				String s_rate = br.readLine();
				float f_rate = Float.parseFloat(s_rate);
				int rate = Math.round(f_rate);
				String s_psnr = bp.readLine().replaceAll(",", ".");
				double psnr = Double.parseDouble(s_psnr);
				sv[i].addInfo(j,rate ,psnr );
			}
			minr= minr+sv[i].getRate(0);maxr = maxr+sv[i].getRate(3);
			int f = sv[i].getRate(0)/50; if(sv[i].getRate(0)%50 !=0)f++; minf = minf+f;
			f = sv[i].getRate(3)/50; if(sv[i].getRate(0)%50 !=0)f++; maxf = maxf+f;
			minp= minp+sv[i].getPSNR(0);maxp = maxp+sv[i].getPSNR(3);
			//sv[i].print();
		}
		//System.out.println("minF="+minf+" maxF="+maxf+" minR="+minr+" maxR="+maxr+" minQ="+minp+" maxQ="+maxp);
		return sv;
	}
	
	public static ScalableVideo[][] get1s10s()throws Exception{
		ScalableVideo[][] sv = new ScalableVideo[10][10];
		String[] names = {"CREW","FOOTBALL","MOBILE","CITY","FOREMAN","BUS","NEWS","HARBOUR","SOCCER","ICE"};
		String[] sec = {"1st","2nd","3rd","4th","5th","6th","7th","8th","9th","xth"};
		for(int i=0; i<sec.length;i++){
			BufferedReader br = new BufferedReader(new FileReader(sec[i]+"/rates.txt"));
			BufferedReader bp = new BufferedReader(new FileReader(sec[i]+"/psnrs.txt"));
			int minr,maxr; minr = maxr =0;
			int minf,maxf; minf = maxf =0;
			double minp,maxp; minp = maxp =0.0;
			for(int j=0 ; j<names.length ; j++){
				sv[i][j] = new ScalableVideo(sec[i]+"_"+names[j],4);
				for(int k=0;k<4;k++){
					String s_rate = br.readLine();//System.out.println(s_rate);
					float f_rate = Float.parseFloat(s_rate);
					int rate = Math.round(f_rate);
					String s_psnr = bp.readLine().replaceAll(",", ".");
					double psnr = Double.parseDouble(s_psnr);
					sv[i][j].addInfo(k,rate ,psnr );
				}
				minr= minr+sv[i][j].getRate(0);maxr = maxr+sv[i][j].getRate(3);
				int f = sv[i][j].getRate(0)/50; if(sv[i][j].getRate(0)%50 !=0)f++; minf = minf+f;
				f = sv[i][j].getRate(3)/50; if(sv[i][j].getRate(0)%50 !=0)f++; maxf = maxf+f;
				minp= minp+sv[i][j].getPSNR(0);maxp = maxp+sv[i][j].getPSNR(3);
				
				//sv[i][j].print();
			}
			//String s_minp = new Double(minp/10).toString().substring(0, 6);String s_maxp = new Double(maxp/10).toString().substring(0, 6);
			//System.out.println("minF="+minf+" maxF="+maxf+" minR="+minr+" maxR="+maxr+" minQ="+s_minp+" maxQ="+s_maxp);
		}
		
		//System.out.println("");
		ScalableVideo[][] dsv = new ScalableVideo[sec.length][names.length];
		for(int i = 0;i<sec.length;i++){
			int minr,maxr; minr = maxr =0;
			int minf,maxf; minf = maxf =0;
			double minp,maxp; minp = maxp =0.0;
			for(int j=0;j<names.length;j++){
				dsv[i][j] = new ScalableVideo(sv[i][j].name,sv[i][j].numL);
				dsv[i][j].addInfo(0, sv[i][j].getRate(0), sv[i][j].getPSNR(0));
				for(int k=1;k<4;k++)
					dsv[i][j].addInfo(k, sv[i][j].getRate(k)-sv[i][j].getRate(k-1), sv[i][j].getPSNR(k)-sv[i][j].getPSNR(k-1));
				
				minr= minr+sv[i][j].getRate(0);maxr = maxr+sv[i][j].getRate(3);
				int f = sv[i][j].getRate(0)/50; if(sv[i][j].getRate(0)%50 !=0)f++; minf = minf+f;
				f = sv[i][j].getRate(3)/50; if(sv[i][j].getRate(0)%50 !=0)f++; maxf = maxf+f;
				minp= minp+sv[i][j].getPSNR(0);maxp = maxp+sv[i][j].getPSNR(3);
				//dsv[i][j].print();
			}
			//String s_minp = new Double(minp/10).toString().substring(0, 6);String s_maxp = new Double(maxp/10).toString().substring(0, 6);
			//System.out.print("minF="+minf+" maxF="+maxf+" minR="+minr+" maxR="+maxr+" minQ="+s_minp+" maxQ="+maxp+" ");
		}
		//System.out.println("");
		return dsv;
	}
	public static void init()throws Exception{
		//extend all yuvs to 300 frames
		/*extend_yuv("BUS_352x288_30_150.yuv","orig/BUS_352x288_30_300.yuv",352,288,150,300);
		extend_yuv("ICE_352x288_30_240.yuv","orig/ICE_352x288_30_300.yuv",352,288,240,300);
		extend_yuv("FOOTBALL_352x288_30_260.yuv","orig/FOOTBALL_352x288_30_300.yuv",352,288,260,300);*/
		
		String[] tc1 = {"1st","2nd","3rd","4th","5th","6th","7th","8th","9th","xth"};
		for(int i =0;i<tc1.length;i++){
			//test1_config(tc1[i],(i*30),30);
			//System.out.println("\n "+tc1[i]+" setup config done.");
			//test1_encode(tc1[i]);
			//System.out.println("\n "+tc1[i]+" encode config done.");
			decode(tc1[i]);
			System.out.println("\n "+tc1[i]+" decode config done.");
		}
		System.out.println("\n run script test1.pl");
	}
	public static void extend_yuv(String fname,String recon,int w,int h, int origf,int destf)throws Exception{
		new File(recon).delete();
		YUVHandler orig = new YUVHandler(fname,origf,w,h);
		YUVHandler ex = YUVHandler.make_test(destf, w,h);
		int i = 0;
		for(;i<origf;i++){
			ex.setY(i,orig.getY(i));
			ex.setCb(i,orig.getCb(i));
			ex.setCr(i,orig.getCr(i));
		}
		for(int j=0;i<destf;i++,j++){
			ex.setY(i,orig.getY(j));
			ex.setCb(i,orig.getCb(j));
			ex.setCr(i,orig.getCr(j));
			if(j== origf) j=0;
		}
		ex.export(recon);
		System.out.println("Done.");
	}
	public static void config(String prefix,int start,int num)throws Exception{
		File dir = new File("./orig/");
	    String[] fnames = dir.list();
	    for(int i=0;i<fnames.length;i++){
	    	String no_ext = fnames[i].substring(0, fnames[i].length()-4);
	    	String[] params = no_ext.split("_");
	    	String[] dim = params[1].split("x");
	    	String name = params[0];
	    	int w = Integer.parseInt(dim[0]);
	    	int h = Integer.parseInt(dim[1]);
	    	int fps = Integer.parseInt(params[2]);
	    	int nf = Integer.parseInt(params[3]);
	    	String orig_chopped = prefix+"/orig/"+name+"_"+w+"x"+h+"_"+num+".yuv";
	    	YUVHandler orig = new YUVHandler("./orig/"+fnames[i],nf,w,h);
	    	YUVHandler dest = YUVHandler.make_test(num,w,h);
	    	for(int j=start;j<(start+num);j++){
	    		dest.setY((j-start), orig.getY(j));
	    		dest.setCb((j-start), orig.getCb(j));
	    		dest.setCr((j-start), orig.getCr(j));
	    	}
	    	System.out.print("Copied "+num+" frames");
	    	dest.export(orig_chopped);
	    	System.out.println(" and written to file "+orig_chopped);
	    	write_config_files(prefix,name,w,h,fps);
	    	System.out.println("Writing SVC config files for "+name+"... done.");
	    }
	}
	public static void encode(String prefix)throws Exception{
		File dir = new File("./orig/");
	    String[] fnames = dir.list();
	    String script_path = prefix+"/encode.txt";
		new File(script_path).delete();
		PrintWriter pw = new PrintWriter(new FileWriter(script_path));
	    for(int i=0;i<fnames.length;i++){
	    	String no_ext = fnames[i].substring(0, fnames[i].length()-4);
	    	//System.out.println(no_ext);
	    	String[] params = no_ext.split("_");
	    	//String[] dim = params[1].split("x");
	    	String name = params[0];

	    	String cmd = "../../jvt/jsvm/bin/H264AVCEncoderLibTestStatic -pf "+prefix+"/cfg/"+name+"_main.cfg -lqp 0 36 -lqp 1 32 -lqp 2 30 -lqp 3 28";
	    	System.out.println(cmd);
	    	pw.println(cmd);
	    }
	    pw.close();
	}
	public static void decode(String prefix)throws Exception{
		File dir = new File("./orig/");
	    String[] fnames = dir.list();
	    String decode_path = prefix+"/decode.txt";
		new File(decode_path).delete();
		PrintWriter pw = new PrintWriter(new FileWriter(decode_path));
		String extract_path = prefix+"/extract.txt";
		new File(extract_path).delete();
		PrintWriter pwe = new PrintWriter(new FileWriter(extract_path)); System.out.println(extract_path);
	    for(int i=0;i<fnames.length;i++){
	    	String no_ext = fnames[i].substring(0, fnames[i].length()-4);
	    	String[] params = no_ext.split("_");
	    	String[] dim = params[1].split("x");
		  	String name = params[0];
		   	int w = Integer.parseInt(dim[0]);
			int h = Integer.parseInt(dim[1]);
			int fps = Integer.parseInt(params[2]);
			String orig_chopped = prefix+"/orig/"+name+"_"+w+"x"+h+"_"+fps+".yuv";
			int layers = 2; String cmd ="";
			for(int j=0;j<4;j++){
				layers = layers*2;
				cmd = "../../jvt/jsvm/bin/BitStreamExtractorStatic "+prefix+"/svc/"+name+".svc "+prefix+"/svc/"+name+"_layer"+j+".svc -sl "+(layers-1)+"|grep , > "+prefix+"/svc/"+name+"_rates.txt";
				System.out.println(cmd);
				pw.println(cmd);
				cmd = "../../jvt/jsvm/bin/H264AVCDecoderLibTestStatic "+prefix+"/svc/"+name+"_layer"+j+".svc "+prefix+"/recon/"+name+"_layer"+j+".yuv";
				System.out.println(cmd);
				pw.println(cmd);
	   			cmd = "../../jvt/jsvm/bin/PSNRStatic "+w+" "+h+" "+orig_chopped+" "+prefix+"/recon/"+name+"_layer"+j+".yuv > "+prefix+"/recon/"+name+"_layer"+j+"_psnr.txt";
	   			System.out.println(cmd);
	   			pw.println(cmd);
	   		   	cmd = "cat "+prefix+"/svc/"+name+"_rates.txt |head -n "+layers+"|tail -n 1|awk '{print $4}' >> "+prefix+"/rates.txt";
	   		   	System.out.println(cmd);
	   		   	pwe.println(cmd);
	   		   	cmd = "cat "+prefix+"/recon/"+name+"_layer"+j+"_psnr.txt |tail -n 2|head -n 1|awk '{print $2}' >> "+prefix+"/psnrs.txt";
	   		   	System.out.println(cmd);
	   		   	pwe.println(cmd);
	   		}
	    }
	    pw.close();
	    pwe.close();
	}
	public static void write_config_files(String prefix,String name,int w,int h, int fps)throws Exception{
		int n = 4;
		//System.out.println(""+n);
		String main_cfg_path = prefix+"/cfg/"+name+"_main.cfg";
		String main_svc_path = prefix+"/svc/"+name+".svc";
		String layer_cfg_path = prefix+"/cfg/"+name+"_layer";
		String orig_yuv_path = prefix+"/orig/"+name+"_"+w+"x"+h+"_"+fps+".yuv";
		new File(main_cfg_path).delete();
		PrintWriter pw = new PrintWriter(new FileWriter(main_cfg_path));
		pw.println("OutputFile        "+main_svc_path+" # Bitstream file");
		pw.println("FrameRate         "+fps+".0              # Frame rate");
		pw.println("FramesToBeEncoded "+fps+"              # Number of frames");
		pw.println(main_common);
		pw.println("NumLayers 		  "+n+"          # Number of layers");
		String[] layer = new String[n];
		for(int i=0;i<n;i++){
			layer[i] = layer_cfg_path+i+".cfg";
			pw.println("LayerCfg   "+layer[i]+"  # Layer "+i+" config file");
			new File(layer[i]).delete();
			PrintWriter plw = new PrintWriter(new FileWriter(layer[i]));
			plw.println("InputFile      "+orig_yuv_path+" # Input file");
			plw.println("SourceWidth   "+w+"    # Input frame width");
			plw.println("SourceHeight  "+h+"    # Input frame height");
			plw.println("FrameRateIn   "+fps+"  # Input frame rate [Hz]");
			plw.println("FrameRateOut  "+fps+"  # Output frame rate [Hz]");
			switch(i){
			case 1:
				plw.println("InterLayerPred 2   # Inter-layer Prediction (0: no, 1: yes, 2:adaptive)");
				plw.println("MGSVectorMode  1   # MGS vector usage selection");
				plw.println("MGSVector0     16   # Specifies 0th position of the vector");
				break;
			case 2:
				plw.println("InterLayerPred 2   # Inter-layer Prediction (0: no, 1: yes, 2:adaptive)");
				plw.println("MGSVectorMode  1   # MGS vector usage selection");
				plw.println("MGSVector0     8	# Specifies 0th position of the vector");
				plw.println("MGSVector1     8 	# Specifies 1st position of the vector");
				break;
			case 3:
				plw.println("InterLayerPred 2 	# Inter-layer Prediction (0: no, 1: yes, 2:adaptive)");
				plw.println("MGSVectorMode 	1   # MGS vector usage selection");
				plw.println("MGSVector0 	4 	# Specifies 0th position of the vector");
				plw.println("MGSVector1 	4 	# Specifies 1st position of the vector");
				plw.println("MGSVector2 	4 	# Specifies 2nd position of the vector");
				plw.println("MGSVector3 	4 	# Specifies 3rd position of the vector");
				break;
			default:
				plw.println("MGSVectorMode 0             # MGS vector usage selection");
				break;
			}
			plw.close();
		}
		pw.close();	
		
	}
	static String main_common = "GOPSize           8                # GOP Size\n" +
	"BaseLayerMode     2                 # Base layer mode\n" +
	"SearchMode        4                 # Search mode\n" +
	"SearchRange       32                # Search range\n" +
	"CgsSnrRefinement  1                 # 1: MGS; 0: CGS\n" +
	"EncodeKeyPictures 1                 # 0:none, 1:MGS, 2:all\n" +
	"MGSControl        2                 # ME/MC for non-key pics";
	public static ScalableVideo[][] get10c1s20m()throws Exception{
		int M = 20*6;
		ScalableVideo[][] tsv = new ScalableVideo[M*10][10];
		ScalableVideo[][] sv = new ScalableVideo[10][10];
		String[] names = {"CREW","FOOTBALL","MOBILE","CITY","FOREMAN","BUS","NEWS","HARBOUR","SOCCER","ICE"};
		String[] sec = {"1st","2nd","3rd","4th","5th","6th","7th","8th","9th","xth"};
		for(int i=0; i<sec.length;i++){
			BufferedReader br = new BufferedReader(new FileReader(sec[i]+"/rates.txt"));
			BufferedReader bp = new BufferedReader(new FileReader(sec[i]+"/psnrs.txt"));
			int minr,maxr; minr = maxr =0;
			int minf,maxf; minf = maxf =0;
			double minp,maxp; minp = maxp =0.0;
			for(int j=0 ; j<names.length ; j++){
				sv[i][j] = new ScalableVideo(sec[i]+"_"+names[j],4);
				for(int k=0;k<4;k++){
					String s_rate = br.readLine();//System.out.println(s_rate);
					float f_rate = Float.parseFloat(s_rate);
					int rate = Math.round(f_rate);
					String s_psnr = bp.readLine().replaceAll(",", ".");
					double psnr = Double.parseDouble(s_psnr);
					sv[i][j].addInfo(k,rate ,psnr );
				}
				minr= minr+sv[i][j].getRate(0);maxr = maxr+sv[i][j].getRate(3);
				int f = sv[i][j].getRate(0)/50; if(sv[i][j].getRate(0)%50 !=0)f++; minf = minf+f;
				f = sv[i][j].getRate(3)/50; if(sv[i][j].getRate(0)%50 !=0)f++; maxf = maxf+f;
				minp= minp+sv[i][j].getPSNR(0);maxp = maxp+sv[i][j].getPSNR(3);
				
				//sv[i][j].print();
			}
			//String s_minp = new Double(minp/10).toString().substring(0, 6);String s_maxp = new Double(maxp/10).toString().substring(0, 6);
			//System.out.println("minF="+minf+" maxF="+maxf+" minR="+minr+" maxR="+maxr+" minQ="+s_minp+" maxQ="+s_maxp);
		}
		
		//System.out.println("");
		//ScalableVideo[][] dsv = new ScalableVideo[sec.length][names.length];
		for(int i = 0;i<sec.length;i++){
			int minr,maxr; minr = maxr =0;
			int minf,maxf; minf = maxf =0;
			double minp,maxp; minp = maxp =0.0;
			for(int j=0;j<names.length;j++){
				tsv[i][j] = new ScalableVideo(sv[i][j].name,sv[i][j].numL);
				tsv[i][j].addInfo(0, sv[i][j].getRate(0), sv[i][j].getPSNR(0));
				for(int k=1;k<4;k++)
					tsv[i][j].addInfo(k, sv[i][j].getRate(k)-sv[i][j].getRate(k-1), sv[i][j].getPSNR(k)-sv[i][j].getPSNR(k-1));
				
				minr= minr+sv[i][j].getRate(0);maxr = maxr+sv[i][j].getRate(3);
				int f = sv[i][j].getRate(0)/50; if(sv[i][j].getRate(0)%50 !=0)f++; minf = minf+f;
				f = sv[i][j].getRate(3)/50; if(sv[i][j].getRate(0)%50 !=0)f++; maxf = maxf+f;
				minp= minp+sv[i][j].getPSNR(0);maxp = maxp+sv[i][j].getPSNR(3);
				//dsv[i][j].print();
			}
			//String s_minp = new Double(minp/10).toString().substring(0, 6);String s_maxp = new Double(maxp/10).toString().substring(0, 6);
			//System.out.print("minF="+minf+" maxF="+maxf+" minR="+minr+" maxR="+maxr+" minQ="+s_minp+" maxQ="+maxp+" ");
		}
		//System.out.println("");
		for(int m=1;m<M;m++){
			int start  = rand.nextInt(10);
			for(int s= 0;s<(sec.length-start);s++){
				for(int j=0;j<names.length;j++){
					//System.out.print("["+(m*sec.length+s)+" "+(start+s)+"]");
					tsv[m*sec.length+s][j] = new ScalableVideo(sv[start+s][j].name,sv[start+s][j].numL);
					tsv[m*sec.length+s][j].addInfo(0, sv[start+s][j].getRate(0), sv[start+s][j].getPSNR(0));
					for(int k=1;k<4;k++)
						tsv[m*sec.length+s][j].addInfo(k, sv[start+s][j].getRate(k)-sv[start+s][j].getRate(k-1), sv[start+s][j].getPSNR(k)-sv[start+s][j].getPSNR(k-1));
						
				}
			}
			//System.out.print("[====]");
			for(int s= sec.length-start;s<sec.length;s++){
				for(int j=0;j<names.length;j++){
					//System.out.print("["+(m*sec.length+s)+" "+(s-(sec.length-start))+"]");
					int idx = s-(sec.length-start);
					tsv[m*sec.length+s][j] = new ScalableVideo(sv[idx][j].name,sv[idx][j].numL);
					tsv[m*sec.length+s][j].addInfo(0, sv[idx][j].getRate(0), sv[idx][j].getPSNR(0));
					for(int k=1;k<4;k++)
						tsv[m*sec.length+s][j].addInfo(k, sv[idx][j].getRate(k)-sv[idx][j].getRate(k-1), sv[idx][j].getPSNR(k)-sv[idx][j].getPSNR(k-1));
						
				}
			}	
			//System.out.println();
		}
		return tsv;
	}
	public static ScalableVideo[][] get20c1s20m()throws Exception{
		int M = 20*6; int NC = 2;
		ScalableVideo[][] tsv = new ScalableVideo[M*10][NC*10];
		ScalableVideo[][] sv = new ScalableVideo[10][10];
		String[] names = {"CREW","FOOTBALL","MOBILE","CITY","FOREMAN","BUS","NEWS","HARBOUR","SOCCER","ICE"};
		String[] sec = {"1st","2nd","3rd","4th","5th","6th","7th","8th","9th","xth"};
		for(int i=0; i<sec.length;i++){
			BufferedReader br = new BufferedReader(new FileReader(sec[i]+"/rates.txt"));
			BufferedReader bp = new BufferedReader(new FileReader(sec[i]+"/psnrs.txt"));
			int minr,maxr; minr = maxr =0;
			int minf,maxf; minf = maxf =0;
			double minp,maxp; minp = maxp =0.0;
			for(int j=0 ; j<names.length ; j++){
				sv[i][j] = new ScalableVideo(sec[i]+"_"+names[j],4);
				for(int k=0;k<4;k++){
					String s_rate = br.readLine();//System.out.println(s_rate);
					float f_rate = Float.parseFloat(s_rate);
					int rate = Math.round(f_rate);
					String s_psnr = bp.readLine().replaceAll(",", ".");
					double psnr = Double.parseDouble(s_psnr);
					sv[i][j].addInfo(k,rate ,psnr );
				}
				minr= minr+sv[i][j].getRate(0);maxr = maxr+sv[i][j].getRate(3);
				int f = sv[i][j].getRate(0)/50; if(sv[i][j].getRate(0)%50 !=0)f++; minf = minf+f;
				f = sv[i][j].getRate(3)/50; if(sv[i][j].getRate(0)%50 !=0)f++; maxf = maxf+f;
				minp= minp+sv[i][j].getPSNR(0);maxp = maxp+sv[i][j].getPSNR(3);
				
				//sv[i][j].print();
			}
			//String s_minp = new Double(minp/10).toString().substring(0, 6);String s_maxp = new Double(maxp/10).toString().substring(0, 6);
			//System.out.println("minF="+minf+" maxF="+maxf+" minR="+minr+" maxR="+maxr+" minQ="+s_minp+" maxQ="+s_maxp);
		}
		
		//System.out.println("");
		//ScalableVideo[][] dsv = new ScalableVideo[sec.length][names.length];
		for(int i = 0;i<sec.length;i++){
			int minr,maxr; minr = maxr =0;
			int minf,maxf; minf = maxf =0;
			double minp,maxp; minp = maxp =0.0;
			
			for(int j=0;j<names.length;j++){
				tsv[i][j] = new ScalableVideo(sv[i][j].name,sv[i][j].numL);
				tsv[i][j].addInfo(0, sv[i][j].getRate(0), sv[i][j].getPSNR(0));
				for(int k=1;k<4;k++)
					tsv[i][j].addInfo(k, sv[i][j].getRate(k)-sv[i][j].getRate(k-1), sv[i][j].getPSNR(k)-sv[i][j].getPSNR(k-1));
				
				minr= minr+sv[i][j].getRate(0);maxr = maxr+sv[i][j].getRate(3);
				int f = sv[i][j].getRate(0)/50; if(sv[i][j].getRate(0)%50 !=0)f++; minf = minf+f;
				f = sv[i][j].getRate(3)/50; if(sv[i][j].getRate(0)%50 !=0)f++; maxf = maxf+f;
				minp= minp+sv[i][j].getPSNR(0);maxp = maxp+sv[i][j].getPSNR(3);
				//dsv[i][j].print();
			}
			for(int n =1;n<NC;n++){
				int start  = rand.nextInt(10);
				for(int s= 0;s<(sec.length-start);s++){
					for(int j=0;j<names.length;j++){
						//System.out.print("["+(m*sec.length+s)+" "+(start+s)+"]");
						tsv[i][n*names.length+j] = new ScalableVideo(sv[start+s][j].name,sv[start+s][j].numL);
						tsv[i][n*names.length+j].addInfo(0, sv[start+s][j].getRate(0), sv[start+s][j].getPSNR(0));
						for(int k=1;k<4;k++)
							tsv[i][n*names.length+j].addInfo(k, sv[start+s][j].getRate(k)-sv[start+s][j].getRate(k-1), sv[start+s][j].getPSNR(k)-sv[start+s][j].getPSNR(k-1));
							
					}
				}
				//System.out.print("[====]");
				for(int s= sec.length-start;s<sec.length;s++){
					for(int j=0;j<names.length;j++){
						//System.out.print("["+(m*sec.length+s)+" "+(s-(sec.length-start))+"]");
						int idx = s-(sec.length-start);
						tsv[i][n*names.length+j] = new ScalableVideo(sv[idx][j].name,sv[idx][j].numL);
						tsv[i][n*names.length+j].addInfo(0, sv[idx][j].getRate(0), sv[idx][j].getPSNR(0));
						for(int k=1;k<4;k++)
							tsv[i][n*names.length+j].addInfo(k, sv[idx][j].getRate(k)-sv[idx][j].getRate(k-1), sv[idx][j].getPSNR(k)-sv[idx][j].getPSNR(k-1));
							
					}
				}
			}
			//String s_minp = new Double(minp/10).toString().substring(0, 6);String s_maxp = new Double(maxp/10).toString().substring(0, 6);
			//System.out.print("minF="+minf+" maxF="+maxf+" minR="+minr+" maxR="+maxr+" minQ="+s_minp+" maxQ="+maxp+" ");
		}
		//System.out.println("");
		for(int m=1;m<M;m++){
			for(int n =0;n<NC;n++){
				int start  = rand.nextInt(10);
				for(int s= 0;s<(sec.length-start);s++){
					for(int j=0;j<names.length;j++){
						System.out.print("["+(m*sec.length+s)+" "+(n*names.length+j)+" "+(start+s)+"]");
						/*tsv[m*sec.length+s][n*names.length+j] = new ScalableVideo(sv[start+s][j].name,sv[start+s][j].numL);
						tsv[m*sec.length+s][n*names.length+j].addInfo(0, sv[start+s][j].getRate(0), sv[start+s][j].getPSNR(0));
						for(int k=1;k<4;k++)
							tsv[m*sec.length+s][n*names.length+j].addInfo(k, sv[start+s][j].getRate(k)-sv[start+s][j].getRate(k-1), sv[start+s][j].getPSNR(k)-sv[start+s][j].getPSNR(k-1));
							*/
					}
				}
				System.out.print("[====]");
				for(int s= sec.length-start;s<sec.length;s++){
					for(int j=0;j<names.length;j++){
						System.out.print("["+(m*sec.length+s)+" "+(n*names.length+j)+" "+(s-(sec.length-start))+"]");
						/*int idx = s-(sec.length-start);
						tsv[m*sec.length+s][n*names.length+j] = new ScalableVideo(sv[idx][j].name,sv[idx][j].numL);
						tsv[m*sec.length+s][n*names.length+j].addInfo(0, sv[idx][j].getRate(0), sv[idx][j].getPSNR(0));
						for(int k=1;k<4;k++)
							tsv[m*sec.length+s][n*names.length+j].addInfo(k, sv[idx][j].getRate(k)-sv[idx][j].getRate(k-1), sv[idx][j].getPSNR(k)-sv[idx][j].getPSNR(k-1));
						*/	
					}
				}
			}
			System.out.println();
		}
		return tsv;
	}
}
