package test;
import src.OrVid;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.PriorityQueue;

import src.Layers;
import src.ScalableVideo;

public class TestCase7 {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		new TestCase7().bq_sch();
	}
	
	public  void bq_sch()throws Exception{
		ScalableVideo[] tsv = TestCase0.getNTData(1,1)[0];
		double ep = 0.005;
		int cap = 10*1000;//kbytes
		int W = 0; double P = 0.0;
		ScalableVideo[] sv = new ScalableVideo[10];
		for(int s=0;s<tsv.length;s++){
    		W = W + tsv[s].getRate(0);
    		P = P + tsv[s].getPSNR(0);
			sv[s]= new ScalableVideo(3);
			for(int l=1;l<4;l++)
			sv[s].addInfo(l-1, tsv[s].getRate(l), tsv[s].getPSNR(l));
		}
		int[] maxl = solve_knapsack(sv,W,P,cap,ep);
				
	}
    int[] solve_knapsack(ScalableVideo[] sv, int W, double P, int C, double ep){
    	int L =3;
    	double[][] x = new double[sv.length][L];
    	for(int s=0;s<sv.length;s++)
    		for(int l=0;l<L;l++)
    			x[s][l]=0.0;
    		
    	
    	for(int s=0;s<sv.length;s++){
    		System.out.print("("+s+","+0+")=["+sv[s].getRate(0)+", "+sv[s].getPSNR(0)+"]");
    		for(int l=1;l<L;l++){
    			int r = sv[s].getRate(l);
    			double q = sv[s].getPSNR(l);
    			//sv[s].addInfo(l, r, q+sv[s].getPSNR(0));
    			System.out.print("("+s+","+l+")=["+sv[s].getRate(l)+", "+sv[s].getPSNR(l)+"]");
    		}
    		System.out.println();
    	}
    	System.out.println();
    	
    	//find the LMCKP
    	//1. Calculate slopes of non-dominated items and sort in non-decreasing order
    	double[][] lambda = new double[sv.length][L];
    	PriorityQueue<OrVid> pq = new PriorityQueue<OrVid>(); 
    	
    	for(int s=0;s<sv.length;s++){
    		for(int l=0;l<L;l++){
    			lambda[s][l] = (sv[s].getPSNR(l))/(sv[s].getRate(l));
    			pq.add(new OrVid(s,l,lambda[s][l]));
    			System.out.print("("+s+","+l+")=["+lambda[s][l]+"]");
    		}
    		System.out.println();
    	}
    	while(!pq.isEmpty()){
    		System.out.print("C="+C+" W="+W+" P="+P+" ");
    		OrVid v = pq.poll();System.out.print(v);
    		int s = v.getS(); int l = v.getL();
    		System.out.println("W + r["+s+"]["+l+"]= "+(W + sv[s].getRate(l)));
    		if(W + sv[s].getRate(l) > C){
    			if(W == C){
    				System.out.println(" Optimal Solution Value="+P);
    				break;
    			}
    			else{
    				//OrVid vbar = pq.poll();System.out.println(vbar);
    				//int sbar = vbar.getS(); int lbar = vbar.getL();
    				int sbar = v.getS(); int lbar = v.getL();
    				x[sbar][lbar] = (C-W)/(sv[sbar].getRate(lbar)-sv[sbar].getRate(lbar-1));
    				x[sbar][lbar-1] = 1-x[sbar][lbar];
    			}
    		}
    		else{
    			x[s][l] = 1.0; x[s][l-1]=0.0;
    		   	for(int i=0;i<sv.length;i++){
    	    		for(int j=0;j<L;j++){
    	    			System.out.print("x["+i+"]["+j+"]="+x[i][j]+" ");
    	    		}
    	    		System.out.println();
    	    	}
    		   	System.out.println("r[i][j]="+sv[s].getRate(l)+" q[i][j]="+sv[s].getPSNR(l));
    			W = W + sv[s].getRate(l) - sv[s].getRate(l-1);
    			P = P + sv[s].getPSNR(l) - sv[s].getPSNR(l-1);
    		}
    	}
    	for(int s=0;s<sv.length;s++){
    		for(int l=0;l<L;l++){
    			System.out.print("("+s+","+l+")=["+x[s][l]+"]");
    		}
    		System.out.println();
    	}
    	System.out.println();
    	int[] res = new int[10];
    	return res;
    		
    }
    public void ppqq(PriorityQueue<OrVid> pq){
		PriorityQueue<OrVid> tq = new PriorityQueue<OrVid>(pq);
		while(!tq.isEmpty()){
			OrVid s = tq.poll();
			System.out.println(s);
		}
		System.out.println("--------------");
	}
}
